# 使用前必读

## 爬虫种类简介

feapder爬虫框架内置三种爬虫

1. AirSpider - 轻量级爬虫
2. Spider - 分布式爬虫
3. BatchSpider - 分布式批次爬虫

**一、AirSpider :**

轻量爬虫，学习成本低。面对一些数据量较少，无需断点续爬，无需分布式采集的需求，可采用此爬虫。
 
**二、Spider :**

分布式爬虫，适用于海量数据采集，支持断点续爬、爬虫报警、数据自动入库等功能


**三、BatchSpider**

分布式批次爬虫，对于需要周期性采集的数据，优先考虑使用本爬虫。

本爬虫会自动维护个批次信息表，详细的记录了每个批次时间、任务完成情况、批次周期等信息，示例数据如下
![-w899](http://markdown-media.oss-cn-beijing.aliyuncs.com/2020/12/20/16084680404224.jpg)

另外本爬虫与其他爬虫最大的区别是，会维护个批次时间信息，本批次未完成下一批次不会开始。

举个例子

> 需求：每7天全量抓取一次商品价格信息。表结构需要包含每个批次信息

表设计如下：

| 字段 | 说明 |
| --- | --- |
| id | 主键 |
| item_id | 商品id |
| price | 价格 |
| crawl_time | 采集时间 |
| batch_date | 批次时间 |

数据示例

| id | item_id | price | crawl_time | batch_date |
| --- | --- | --- | --- | --- |
| 1 | 3213 | 99 | 2021-01-01 | 2021-01-01 |
| 2 | 3214 | 90 | 2021-01-05 | 2021-01-01 |
| 3 | 3213 | 95 | 2021-01-08 | 2021-01-08 |
| 4 | 3214 | 92 | 2021-01-20| 2021-01-08 |

从数据示例中可以看到
- id（1，2） 两条数据虽然是不同天采集的，但都归属于2021-01-01这个批次。
- id（3，4） 为7天后抓取的新一批数据，归属于2021-01-08这个批次。
- id为4的数琚，采集时间为20号，虽然已经超出了7天这个维度，但因是采集超时等某种原因导致，为了保证每个批次数据的完整性，仍会归属于2021-01-08这个批次。

BatchSpider爬虫会自动维护这个batch_date， 有了这个batch_date，方便业务做时序数据展示

并且在采集过程中，可随时重启爬虫，若本批次还有剩余任务，会继续抓取，若本批次结束了，下一批次未到时，爬虫会自动退出

## 学习路线

feapder虽然内置三种爬虫，但对于开发者暴露的接口一致。只需要继承不同的类即可，使用方式雷同。

建议学习路线为 AirSpider->Spider->BatchSpider。因为后一个爬虫是基于前一个爬虫丰富而来的，与我们读书 小学->初中->高中这个路线类似
